      parameter (NPROF=40,NX=146755)
      character*32 file_out,file_out2
      character*4 cid
      character*54 line 
      real*8 bid 
      real*8 prof(NPROF),pr(NPROF),pr2(NPROF),tmax(NPROF),T_m(NPROF) 
      real*8 p_x(NX),t_x(NX),rho_x(NX),vs_x(NX)
      real*8 a,b,c,Ju,Jup,T_hom,A_eta,A_p,sig_p,eta,tau_m,pp,J1,J2
      real*8 att,Takei_lnQ,Takei_vs 
      real*8 per,tc2tk,R,Tp_eta,gam,H,eta_r,omega,P_r,T_r,AB,alpha
      real*8 tau_pp,mu_0,dmudT,dmudP,T_0,P_0,T_hirsch,T_tak,T_wet

c   code  by E. Debayle
c   This pgm computes Q and Vs as a function of T 
c   for the temperature model of Takei, 2017
c   The anharmonic Vs at infinite frequency used to computes
c   mu and Ju=1/mu is given by Perle_X 

      pi=4.d0*atan2(1.d0,1.d0)
      write(*,*)'pi= ',pi
c Parametres (d'après Takei 1997)_________________________
c     periode=100s? Yanick prend 200...
      per=100.;
      tc2tk=273.15
      R=8.314462
      Tp_eta=0.94
      gam=5
      H=462500
      omega=7.913e-6
c     eta_d'apres table 2, P_R et T_r footnote b de la table 2
      eta_r=10**21.794
      P_r=1.5e09
      T_r=1200+tc2tk
      AB=0.664
c     tau_pp d'apres table 1
      tau_pp=6e-05
c     d'apres table1
      mu_0=72.45E09
      dmudT=-1.094E07
      dmudP=1.987
      T_0=273.15
      P_0=0.
      write(*,*)'Entrez :'
      write(*,*)'1 pour estimer Ju selon PerpleX'
      write(*,*)'Sinon 2 et Ju sera estime selon Takei'
      read(*,*)iju
      write(*,*)'Entrez la valeur de alpha'
      read(*,*) alpha
      write(*,*)'alpha=',alpha
c ____________________________________
      write(*,*) 'Choisir une méthode de calcul du solidus'
      write(*,*) '1 pour solidus wet Takei AERES, 2017 '
      write(*,*) '2 pour solidus dry Hirshmann '
      write(*,*) '3 pour wet solidus selon Yanick(mail 24/02/2019)15h13'
      read(*,*) isol 
      if(isol.lt.1.or.isol.gt.3)stop 'Pb Isol'

      open(7,file='Ju')
c     lecture fichier Prof, Pression (lue en GPa), Tmax
      open(8,file='../data/Prof_P_Tmax')
c ____________________________________
c 2 mai 2020: pour generer les fichiers T_lnQ_Vs_takei
c a parir de 6 km (utilise uniquement pour convertir un modele
c de refroidissement de plaque en temperature
c en modele de ln(Q) 
c     open(8,file='Prof_P_Tmax_shallow')
c ____________________________________
      ir=1
      iout=11
      iout2=50
5     read(8,1000,end=996)line,prof(ir),bid,pr(ir),tmax(ir)
      itt=int(prof(ir))
      write(cid,'(i4.4)')itt
      file_out='T_lnQ_Vs_takei.'//cid(:lnblnk(cid))//'.xy'
      file_out2='T_fm.'//cid(:lnblnk(cid))//'.xy'
      open(iout,file=file_out)
      open(iout2,file=file_out2)
      iout=iout+1
      iout2=iout2+1
      ir=ir+1
      goto 5
996   continue
      il=ir-1
      write(*,*)il,' lines in Prof_P_Tmax'
      close(8)
1000  format(a54,4(f8.2,2x))

c     lecture du fichier en sortie de Perple_X 
c     Projet_eric3_1.tab : pas de  5 degres en Temperature
      open(8,file='../data/Projet_eric3_1.tab')
      do i=1,13
        read(8,'(a)')line
      enddo
      ir=1
c     Rq : P est lu en bar, t_x(ir) en K,rho en kg/m3, vs en km/s
10    read(8,*,end=999)p_x(ir),t_x(ir),rho_x(ir),vs_x(ir)
c     conversion bar ->GPa
      p_x(ir)=p_x(ir)/1e04
      ir=ir+1
      goto 10
999   continue
      ilx=ir-1
      write(*,*)ilx,' lines in Projet_eric3_1.tab'
      close(8)

c     extraction des pressions du fichier Perple_X 
c     des pressions les plus proches des profondeurs traitées
      open(8,file='solidus_Takei2017')
      open(9,file='solidus_Hirschmann2000')
      open(10,file='solidus_wet200ppm')
      iout=11
      iout2=50
      do j=1,il
       diffmin=100.
       do ix=1,222
         if(abs(pr(j)-p_x(ix)).le.diffmin) then
           diffmin=abs(pr(j)-p_x(ix))
           pr2(j)=p_x(ix)
         endif
       enddo
       write(*,1100)prof(j),pr(j),pr2(j),tmax(j)
1100   format('Prof, P, P Perplex, T_max  ',4(f8.2,2x))
       write(iout2,*)'Rappel: frequence Maxell du manteau=10^-9Hz',
     *'(Takei, 2017, caption Fig. 5)'
c      calcul de T_m a chaque prof
c      façon Takei
         T_tak=1326.+tc2tK+1.018*(prof(j)-50)
c      façon Hirschmann (P en GPa. Cette formule est valide
c      jusqu'a 10 Gpa soit 300 km
         a=-5.104
         b=132.899
         c=1120.661
         T_hirsch=tc2tk+a*pr2(j)**2+b*pr2(j)+c
         
c      Façon Yan, mail  du 24/02/2019 a 15h13
c      on suppose 150 ppm water content d'apres Selway (PAPIER SOUMIS NATURE) 
c      ou 200 ppm d'apres Freitas et manthilake EPSL 2019
         BB=65999.65518+9727.586207*pressure
c        T_wet=(1./T_hirsch)-(R*log(1.-0.017*sqrt(150.))/BB)
         T_wet=(1./T_hirsch)-(R*log(1.-0.017*sqrt(200.))/BB)
         T_wet=1./T_wet
       write(8,*)prof(j),T_tak,T_hirsch,T_wet
       write(9,*)prof(j),T_hirsch
       write(10,*)prof(j),T_wet

       if(isol.eq.1) then
         T_m(j)=T_tak
       else if (isol.eq.2) then
         T_m(j)=T_hirsch
       else if (isol.eq.3) then
         T_m(j)=T_wet
       else
         write(*,*) 'Valeur de isol incorrecte', isol
         stop
       endif

       do ix=1,ilx
        if(p_x(ix).eq.pr2(j)) then
         if(vs_x(ix).ge.0.and.vs_x(ix).lt.20.and.t_x(ix).le.tmax(j))then
c           calcul Ju,T_hom 
c           Calcul de Ju a partir de PerpleX 
c           Ju est en Pa donc on passe Vs SI
            vs_x(ix)=vs_x(ix)*1000. 
            Jup=1./(rho_x(ix)*vs_x(ix)**2)
c           Calcul de Ju selon Takei
            p_x(ix)=p_x(ix)*10**9
            Ju=mu_0+dmudT*(t_x(ix)-T_0)+dmudP*(p_x(ix)-P_0)
            Ju=1./Ju

            write(7,*)prof(j),Jup,Ju,rho_x(ix),vs_x(ix)

            if(iju.eq.1) then
             Ju=Jup 
            endif

            T_hom=t_x(ix)/T_m(j)
c           calcul A_eta
            if (T_hom.lt.Tp_eta) then
              A_eta=1
            else if(T_hom.lt.1) then
              A_eta=exp(-(T_hom-Tp_eta)*log(gam)/(T_hom-T_hom*Tp_eta))
            else
              A_eta=1./gam
            endif
c           calcul A_p   
            if (T_hom.lt.0.91) then
              A_p=0.01
            else if (T_hom.lt.0.96) then
              A_p=0.01+0.4*(T_hom-0.91)
            else
              A_p=0.03
            endif
c           calcul sig_p   
            if (T_hom.lt.0.92) then
               sig_p=4.
            else if (T_hom.lt.1) then
               sig_p=4.+37.5*(T_hom-0.92)
            else
               sig_p=7.
            endif         
c           calcul eta
            eta=eta_r*exp((H/R)*(1./t_x(ix)-1./T_r))*
     *exp((omega/R)*((pr2(j)/t_x(ix))-(P_r/T_r)))*A_eta
c           calcul de la periode de Maxwel taum (eq. 8) et de pp (eq. 21)
            tau_m=eta*Ju
c           verif : ecriture de la frequence de maxwell
            pp=per/(2.*pi*tau_m)
            write(iout2,1500)t_x(ix),1./tau_m,pp
1500        format(f9.2,2(2x,E14.7))

c           calcul J1
            J1=Ju*(1+(AB*(pp**alpha))/alpha+(sqrt(2*pi)/2.)*A_p*
     *sig_p*(1-erf(log(tau_pp/pp)/(sqrt(2.)*sig_p))))
c           calcul J2
            J2=Ju*pi/2.*(AB*(pp**alpha)+A_p*
     *exp(-(log(tau_pp/pp)**2)/(2*(sig_p**2))))+Ju*pp
c           il semble que ce ne soit pas 
c           J1=Ju*(1+(AB**alpha)/alpha+(sqrt(2*pi)/2.)*A_p*
c    *sig_p*(1-erf(log(tau_pp/pp)/(sqrt(2.)*sig_p))))
c           J2=Ju*pi/2.*(AB**alpha+A_p*
c    *exp(-(log(tau_pp/pp)**2)/(2*(sig_p**2))))+Ju*pp

c           coeft d'apres eq. 16 de Yamauchi et Takei JGR, 2016
            coeft=(1+sqrt(1+(J2/J1)**2))/2.
            att=J2/J1*1./coeft
            Takei_lnQ=log(1./att) 
            Takei_vs=1./sqrt(coeft)*1./sqrt(rho_x(ix)*J1)
            write(iout,2000)t_x(ix),Takei_lnQ,Takei_vs/1000.,
     *rho_x(ix),prof(j),pr2(j),p_x(ix)/10**9
c           Test : comparaison avec Fig 10 de Takei 2017
c           La faible difference avec la fig 10. de Takei vient probablement
c           de la densite. En enlevant 2% a la densité donnée par PerPLeX
c           on retrouve parfaitement le 4.37 km/s a 1200°C et 50 km de Takei
c           rho_x(ix)=rho_x(ix)-0.02*rho_x(ix)
c           Takei_vs=1./sqrt(coeft)*1./sqrt(rho_x(ix)*J1)
c           write(iout,2000)t_x(ix)-tc2tk,Takei_vs/1000.,
c    *rho_x(ix),prof(j),pr2(j),p_x(ix)/10**9
2000  format(f5.0,2(f9.4,1x),2x,4(f9.4,1x))
         endif
        endif
       enddo
       iout=iout+1
       iout2=iout2+1
      enddo

      close(7)
      close(8)
      close(9)
      close(10)
c     fermeture des fichiers
      iout=11
      iout2=50
      do j=1,il
        close(iout)
        close(iout2)
        iout=iout+1
        iout2=iout2+1
      enddo
      end
