      parameter(NLAT=90,NLON=180,NLALO=NLAT*NLON,NCOUCH=1000)
      real vlat(NLALO),vlo(NLALO),Qlat(NLALO),Qlo(NLALO) 
      real vvlat(NLALO),vvlo(NLALO),xi_melt_av,xi_melt_avo,xi_melt_avc
      real vs_v(NLALO),vs_h(NLALO),xi_melt(NLALO)
      real vs(NLALO),Qs(NLALO)
      real tecto(NLAT,NLON)
      real tecto2(NLAT,NLON)
      real tecto3(NLALO)
      real Qmin,Qmax,diffmaxdry
      real vsdry(NCOUCH),lnQdry(NCOUCH),tdry(NCOUCH)
      real prof(NCOUCH)
      real tadiab(NCOUCH)
      real tad,tsold,tsoly,tsolw_200,tsolw_800,tsolw_3000 
      real tsoltak
      real tfdry,vssol,coef,vsm,vsok
      real aa,bb,cc,delta,fmelt1,fmelt2,f_melt
      real errQ
      real temp_moyg,coef2,sumcoefg,flatrad,degtorad
      real temp_moyc,sumcoefc
      real temp_moyo,sumcoefo
      character*54 line 
      character*32 file_VsQ
      character*52 fileinvs,fileinQ,fileinvsv
      character*32 fileodry,fileomelt,fileoxi
      character*32 fileorien,fileomap
      character*32 fileomapta,fileomaptd,fileomaptw200,fileomaptw3000
      character*32 fileomaptw800,fileomapttak
      character*4 cid 


      pi=3.14159265359
      degtorad=pi/180.

c     code by Eric Debayle.
c     This code test if the T, ln(Q) and Vs triplet computed with QversusT_tempmodel.f
c     (Takei's 2017 paper) is compatible with the observed Vs given by tomography.
c     
c     we first find the ln(Q) given by QversusT_tempmodel.f that fits the observed ln(Q)
c     in QsADR17 at a given geographical point. We then check if the correspoding Vs predicted 
c     by Takei fits the observed Vs in DR2020s.
c     If it does not, we add melt or we compute a misfit.

      write(*,*)'Entrez une erreur en % sur ln(Q) de la tomo'
      read(*,*)errQ
      errQ=errQ/100.

      write(*,*)'Entrez 1 pour Vs_voigt a partir de DR2012 et Xi PREM'
      write(*,*)'Entrez 2 pour Vs_voigt a partir de DR2012 et Xi SEMUM2'
      read(*,*)idrs

      icobden=0
      write(*,*)'Entrez 1 pour corrections de melt selon Cobden'
      write(*,*)'       0 pour corrections de melt selon Chantel'
      read(*,*)icobden
      write(*,*)'Entrez 1 pour vsm = moyenne cont ou oceanique'
      write(*,*)'       2 pour vsm= vs solidus selon Takei'
      write(*,*)'       3 pour vsm= vs pour T° fitte Q selon Takei'
      read(*,*)ivsm
     
      write(*,*)'__________________________________________'
      write(*,*)'Lecture de datatecto 3SMAC'
      call lecsmac(tecto)
      write(*,*)'Lecture de 3SMAC achevee'
      write(*,*)'__________________________________________'
      jj=90
      do i=1,NLAT
        do j=1,NLON
          jj=j+90
          if(jj.gt.180)jj=jj-180
          tecto2(i,jj)=tecto(i,j)
        enddo
      enddo
      ij=0
      do i=1,NLAT
        do j=1,NLON
        ij=ij+1
        if(tecto2(i,j).lt.3.5) then
           tecto3(ij)=tecto2(i,j)
        else if(tecto2(i,j).eq.8)then
           tecto3(ij)=4
        else
           tecto3(ij)=5
        endif
        enddo
      enddo

      open(27,file='Temp_moyg')
      open(28,file='Temp_moyo')
      open(29,file='Temp_moyc')
      open(32,file='xi_meltavg')
      open(33,file='xi_meltavo')
      open(34,file='xi_meltavc')

      open(9,file='adiabat_solidus')
      write(9,*) 'T_adiabat(K) T_solidus(K) dry wet200 wet3000:'
      open(8,file='../data/Prof_P_Tmax')
      open(67,file='vs_moy')
      write(67,*)'prof,vsmoy,vso,vscon'
      open(68,file='tectosmac.xy')

      ij=1
      iout=10
2000  format(a54,4(f8.2,2x))
10    read(8,2000,end=996)line,prof(ij),fbid,fbid,fbid
      itt=int(prof(ij))
      write(cid,'(i4.4)')itt
      write(*,*)'___________________________________________________'
      write(*,*)'PROF ',itt,ij
      if(idrs.eq.1) then
c       fileinvs='../../DR2012.lisse/vsvoigt.'//cid(:lnblnk(cid))//'.xy'
        fileinvs='../data/vsvoigt.'//cid(:lnblnk(cid))//'.xy'
      else if(idrs.eq.2) then
c     only for testing the SEMUM2 radial anisotropy model (figures in SI)
        fileinvs=
     *'../../SEMum2_dist-v0.1/tri_vsvoigt.'//cid(:lnblnk(cid))//'.xy'
      else
        write(*,*)'IDRS =',idrs
        stop
      endif
c     fileinQ='../../QsADR17/lQ.'//cid(:lnblnk(cid))//'.xy'
      fileinQ='../data/lQ.'//cid(:lnblnk(cid))//'.xy'
c on calcule l adiabat et le solidus a la profondeur itt
c Estimation rapide et grossière de l adiabat et
c des temperatures min et max du manteau 
C le gradient adiabatique de 0.5Kkm-1 sous la lithosphere
c vient de Katsura et al., 2010, Labrosse, slide 24 cours temperature
c la temperature potentielle vient de 1610 k vient de Katsura et al. 2010
      tad=1610.
      tsold=0.
      tsoly=0.
      tsolw_200=0.
      tsolw_800=0.
      tsolw_3000=0.
      tsoltak=0.
      do i=1,itt
       tad=tad+0.5
      enddo
c     tsolw= temperature en K pour wet(3000 ppm H20) solidus d'après mail Yanick
      call solidus(itt,tsold,tsoly,tsolw_3000,tsolw_800,
     *tsolw_200,tsoltak)
      write(*,*)'T_adiabat T_solidus dry wet200 wet800 wet3000 tsoltak:'
     *,tad,tsold,tsolw_200,tsolw_800,tsolw_3000i,tsoltak
      write(9,*)-itt,tad,tsold,tsolw_200,tsolw_800,tsolw_3000,tsoltak

c     lecture fichiers tomo
      Qmin=999999.
      Qmax=0.
      vsmoy=0.
      vso=0
      vscont=0
      ic=0
      io=0
      open(10,file=fileinvs)
      open(12,file=fileinQ)
      do i=1,NLALO
         read(10,*)vlat(i),vlo(i),vs(i)
         if(ij.eq.1)write(68,*)vlat(i),vlo(i),tecto3(i)
         vsmoy=vsmoy+vs(i)
         if(tecto3(i).lt.3.5)then
           vscont=vscont+vs(i)
           ic=ic+1
         else
           vso=vso+vs(i)
           io=io+1
         endif
         if(vlo(i).ge.180)vlo(i)=vlo(i)-360.
         read(12,*)Qlat(i),Qlo(i),Qs(i)
         if(Qlo(i).ge.180)Qlo(i)=Qlo(i)-360.
         if(Qs(i).ge.Qmax)Qmax=Qs(i)
         if(Qs(i).le.Qmin)Qmin=Qs(i)
      enddo
      close(12)
      close(10)
      write(*,*) 'Qmin, Qmax',Qmin,Qmax
      vsmoy=vsmoy/NLALO
      vscont=vscont/ic
      vso=vso/io
      write(67,*)prof(ij),vsmoy,vso,vscont

c     lecture  fichier  T_lnQ_Vs_takei.   
      file_VsQ='T_lnQ_Vs_takei.'//cid(:lnblnk(cid))//'.xy'
      open(10,file=file_VsQ)
      ir=1
      diffmaxdry=0.
20    read(10,*,end=9990)tdry(ir),lnQdry(ir),vsdry(ir)
c     reperage du Vs Takei associé au solidus
      if(ir.ge.2.and.tdry(ir).ge.tsold.and.tdry(ir-1).lt.tsold)then
           coef=(tsold-tdry(ir-1))/(tdry(ir)-tdry(ir-1))
           vssol=vsdry(ir-1)+coef*(vsdry(ir)-vsdry(ir-1))
           write(*,*)'Prof, solidus (K), Vs solidus',itt,tsold,vssol,
     *vsdry(ir),vsdry(ir-1)
           itrouv=1
      endif
c     reperage de la diff max
      if (ir.ge.2) then
        if(abs(lnQdry(ir)-lnQdry(ir-1)).gt.diffmaxdry) then
           diffmaxdry=abs(lnQdry(ir)-lnQdry(ir-1))
        endif
      endif
      ir=ir+1
      go to 20
9990  continue
      ilidry=ir-1
      write(*,*)ilidry,' lines in ',file_VsQ(:lnblnk(file_VsQ))
      write(*,*)'             Diff max in ln(Q) ',diffmaxdry
      close(10) 

      fileinvsv='../data/vsabs.'//cid(:lnblnk(cid))//'.xy'
      fileoxi='ximelt.'//cid(:lnblnk(cid))//'.xy'
      fileodry='okdry.'//cid(:lnblnk(cid))//'.xy'
      fileomelt='okmelt.'//cid(:lnblnk(cid))//'.xy'
      fileorien='okrien.'//cid(:lnblnk(cid))//'.xy'
      fileomap='map.'//cid(:lnblnk(cid))//'.xy'
      fileomapta='mapTa.'//cid(:lnblnk(cid))//'.xy'
      fileomaptd='mapTd.'//cid(:lnblnk(cid))//'.xy'
      fileomaptw200='mapTw200.'//cid(:lnblnk(cid))//'.xy'
      fileomaptw3000='mapTw3000.'//cid(:lnblnk(cid))//'.xy'
      fileomaptw800='mapTw800.'//cid(:lnblnk(cid))//'.xy'
      fileomapttak='mapTtakei.'//cid(:lnblnk(cid))//'.xy'
      open(14,file=fileodry)
      open(17,file=fileomelt)
      open(18,file=fileorien)
      open(19,file=fileomap)
      open(21,file=fileomapta)
      open(22,file=fileomaptd)
      open(23,file=fileomaptw200)
      open(24,file=fileomaptw3000)
      open(25,file=fileomaptw800)
      open(26,file=fileomapttak)
      open(30,file=fileinvsv)
      open(31,file=fileoxi)
      temp_moyg=0.
      coefg=0.
      sumcoefg=0.
      temp_moyo=0.
      coefo=0.
      sumcoefo=0.
      temp_moyc=0.
      coefc=0.
      sumcoefc=0.
      xi_melt_av=0.
      xi_melt_avo=0.
      xi_melt_avc=0.
      do i=1,NLALO
        read(30,*)vvlat(i),vvlo(i),vs_v(i)
        if(vvlat(i).ne.vlat(i))stop'Pb vvlat'
        if(vvlo(i).ne.vlo(i))stop'Pb vvlo'
        do j=1,NLALO
         if(abs(vlat(i)-Qlat(j)).le.1e-5.
     *and.abs(vlo(i)-Qlo(j)).le.1e-5) then
          itest=0
          idry=0
          tfdry=0.
          call testok2(vs(i),Qs(j),errQ,vsdry,lnQdry,tdry,diffmaxdry,
     *vsok,ilidry,itest,tfdry)

          write(21,*)vlat(i),vlo(i),tfdry,tsoltak,tsol,tsolw_200,
     *tsolw_800,tsolw_3000,tad
          write(22,*)vlat(i),vlo(i),tfdry-tsold
          write(23,*)vlat(i),vlo(i),tfdry-tsolw_200
          write(24,*)vlat(i),vlo(i),tfdry-tsolw_3000
          write(25,*)vlat(i),vlo(i),tfdry-tsolw_800
          write(26,*)vlat(i),vlo(i),tfdry-tsoltak

          f_melt=0.
c         on choisit la vs a partir de laquelle on rajoute du melt
          if (ivsm.eq.1) then     
            if(tecto3(i).lt.3.5)then
              vsm=vscont
            else
              vsm=vso
            endif
          else if(ivsm.eq.2) then
c           ne fonctionne pas  car vssol < vs(i) partout
            vsm=vssol
          else if(ivsm.eq.3) then
            vsm=vsok
          else
            write(*,*) 'valeur de ivsm non correcte',ivsm
          endif

c         calcul des temperatures moyennes compatible avec Q
c         et de l'anisotropie moyenne necessaire pour expliquer
c         la difference entre Vs observe et Vs predit 
          xi_melt=0.
          flatrad=vlat(i)*degtorad
          coef2=cos(flatrad)
          temp_moyg=temp_moyg+tfdry*coef2
          vs_h(i)=sqrt(3*(vsm*vsm)-2*(vs_v(i)*vs_v(i)))
          xi_melt(i)=(vs_h(i)*vs_h(i))/(vs_v(i)*vs_v(i))
          xi_melt_av=xi_melt_av+xi_melt(i)*coef2
          sumcoefg=sumcoefg+coef2
c         moyennes pour continents et oceans
          if(tecto3(i).lt.3.5)then
             temp_moyc=temp_moyc+tfdry*coef2
             xi_melt_avc=xi_melt_avc+xi_melt(i)*coef2
             sumcoefc=sumcoefc+coef2
          else
             temp_moyo=temp_moyo+tfdry*coef2
             xi_melt_avo=xi_melt_avo+xi_melt(i)*coef2
             sumcoefo=sumcoefo+coef2
          endif

          if(itest.eq.1.)then
            write(14,*)vs(i),Qs(j),0. 
c           write(14,*)vs(i),exp(-Qs(j)),0. 
            write(19,*)vlat(i),vlo(i),0.
          else if ((vsm-vs(i)).gt.0.) then
c           On ajoute du melt si Vstomo < vsm 
            if(icobden.eq.1) then
c             Cobden
              f_melt=100*((vsm-vs(i))/vsm)/7.9
            else
c             Chantel
              aa=0.065
              bb=-0.5565
              cc=vsok-vs(i)
              delta=bb**2-4*aa*cc
              if(delta.lt.0) then
                 stop 'Delta negatif'
              else if(delta.eq.0) then
                 f_melt=-bb/(2*aa)
              else if(delta.gt.0) then
                 fmelt1=(-bb-sqrt(delta))/(2*aa)
                 fmelt2=(-bb+sqrt(delta))/(2*aa)
                 f_melt=min(fmelt1,fmelt2)
              endif
            endif
            write(17,*)vs(i),Qs(j),f_melt 
c           write(17,*)vs(i),exp(-Qs(j)),f_melt 
            write(19,*)vlat(i),vlo(i),f_melt
          else
c           ici f_melt est un mesure en % de l'écar a l observation
            f_melt=100*((vsm-vs(i))/vsm)
            write(18,*)vs(i),Qs(j),f_melt 
c           write(18,*)vs(i),exp(-Qs(j)),f_melt 
c           write(19,*)vlat(i),vlo(i),f_melt,vsm,vs(i)
            write(19,*)vlat(i),vlo(i),f_melt
          endif
         endif
        enddo
        write(31,*)vvlat(i),vvlo(i),xi_melt(i),vs_h(i),vs_v(i),vsm
      enddo
      xi_melt_av=xi_melt_av/sumcoefg
      xi_melt_avo=xi_melt_avo/sumcoefo
      xi_melt_avc=xi_melt_avc/sumcoefc
      temp_moyg=temp_moyg/sumcoefg
      temp_moyo=temp_moyo/sumcoefo
      temp_moyc=temp_moyc/sumcoefc
      write(27,*)-itt,temp_moyg
      write(28,*)-itt,temp_moyo
      write(29,*)-itt,temp_moyc
      write(32,*)-itt,xi_melt_av
      write(33,*)-itt,xi_melt_avo
      write(34,*)-itt,xi_melt_avc
      close(14)
      close(17)
      close(18)
      close(19)
      close(21)
      close(22)
      close(23)
      close(24)
      close(25)
      close(26)
      close(30)
      close(31)

      ij=ij+1
      goto 10
996   continue
      il=ij-1
      write(*,*)il,' prof in Prof_P_Tmax'
      close(8)
      close(9)
      close(27)
      close(28)
      close(29)
      close(32)
      close(33)
      close(34)
      close(67) 
      close(68)

      end
c------------------------------------------------------------------
      subroutine testok2(vstomo,lnQtomo,errQ,vsc,lnQc,tc,
     *diffmax,vscok,ili,itest,tfinal)
c ------------------------------------------------------------------
      parameter(NLAT=90,NLON=180,NLALO=NLAT*NLON,NCOUCH=50)
      parameter(NPTS=200)
      real vsc(NCOUCH),lnQc(NCOUCH),tc(NCOUCH)
      real vstomo,lnQtomo,errQ,lnQmax,lnQmin
      real vscok,tfinal,delta,percent
      real perc(NPTS),diff(NPTS),vsok(NPTS),tf(NPTS),lnQ(NPTS)
      integer ili,itest,nstep

      vscok=0.
      tfinal=0.
      itest=0
      percent=100.
      lnQmax=lnQtomo+errQ*lnQtomo
      lnQmin=lnQtomo-errQ*lnQtomo
      delta=lnQmax-lnQmin
      nstep=int(100*delta)
      step=delta/float(nstep) 
      nstep=nstep+1
  
      do j=1,nstep
       perc(j)=100.
       diff(j)=100. 
       vsok(j)=0.
       tf(j)=0.
      enddo

      do i=1,ili
       do j=1,nstep
        lnQ(j)=lnQmin+step*(j-1)
        if(abs(lnQ(j)-lnQc(i)).le.diff(j))then
           diff(j)=abs(lnQ(j)-lnQc(i))
           vsok(j)=vsc(i)
           tf(j)=tc(i)
        endif
       enddo
      enddo
      
      do i=1,ili  
       do j=1,nstep
        if(diff(j).le.(diffmax/2.)) then
         perc(j)=abs(100*(vstomo-vsok(j))/vsok(j))
         if(perc(j).lt.percent) then
          percent=perc(j)
          vscok=vsok(j)
          tfinal=tf(j)
         endif
        endif
        if(percent.lt.1.)itest=1
       enddo
      enddo
      return
      end

c ------------------------------------------------------------------
      subroutine testok(vstomo,lnQtomo,errQ,vsc,lnQc,tc,
     *diffmax,vscok,ili,itest,tfinal)
      parameter(NLAT=90,NLON=180,NLALO=NLAT*NLON,NCOUCH=50)
      real vsc(NCOUCH),lnQc(NCOUCH),tc(NCOUCH)
      real vstomo,lnQtomo,errQ,lnQmax,lnQmin
      real vscok,tfinal,vscmax,tfmax,vscmin,tfmin
      real diffmin1,diffmin2,diffimin3
      real percent1,percent2,percent3
      integer ili,itest
    
      percent1=100. 
      percent2=100. 
      percent3=100. 
      tfinal=0. 
      tfmin=0. 
      tfmax=0. 
      vscok=0.
      vscmax=0.
      vscmin=0.
      itest=0
      diffmin1=100.
      diffmin2=100.
      diffmin3=100.
      lnQmax=lnQtomo+errQ*lnQtomo
      lnQmin=lnQtomo-errQ*lnQtomo
      do i=1,ili
       if(abs(lnQtomo-lnQc(i)).le.diffmin1) then
           diffmin1=abs(lnQtomo-lnQc(i))
           vscok=vsc(i)
           tfinal=tc(i)
        endif
       if(abs(lnQmax-lnQc(i)).le.diffmin2) then
           diffmin2=abs(lnQmax-lnQc(i))
           vscmax=vsc(i)
           tfmax=tc(i)
        endif
       if(abs(lnQmin-lnQc(i)).le.diffmin3) then
           diffmin3=abs(lnQmin-lnQc(i))
           vscmin=vsc(i)
           tfmin=tc(i)
        endif
      enddo
      
      if(diffmin1.le.(diffmax/2.)) then
        percent1=abs(100*(vstomo-vscok)/vscok)
      endif
      if(diffmin2.le.(diffmax/2.)) then
        percent2=abs(100*(vstomo-vscmax)/vscmax)
      endif
      if(diffmin3.le.(diffmax/2.)) then
        percent3=abs(100*(vstomo-vscmin)/vscmin)
      endif
      percent=min(percent1,percent2,percent3)      
      if(percent.lt.1.)itest=1
      if(percent.eq.percent2) then
        vscok=vscmax
        tfinal=tfmax
      else if(percent.eq.percent3) then
        vscok=vscmin
        tfinal=tfmin
      else if(percent.ne.percent1) then
        write(*,*)'percent1, 2, 3 ',percent,percent1,percent2,percent3  
        stop
      endif
      return
      end
c ------------------------------------------------------------------
      subroutine solidus(itt,tsold,tsoly,tsolw_3000,tsolw_800,
     *tsolw_200,tsoltak)
      integer itt
      real pressure,coef,tsold,tsoly,tsolw_3000,tsolw_200
      real rad(1000),prof(1000),pres(1000)
      character*36 text
      
      tsold=0.
      tsoly=0.
      tsolw_3000=0.
      tsolw_200=0.
      tsolw_800=0.
      tsoltak=0.
      RR=8.314462
      BB=0.
c     open(10,file='../../input.eric/Radius_Depth_Pressure')
      open(10,file='../data/Radius_Depth_Pressure')
      coef=0.
      pressure=0.
      il=1
10    read(10,*,end=888)rad(il),prof(il),pres(il)
      if (il.ge.2) then
        if(prof(il).lt.itt.and.prof(il-1).ge.itt) then
           coef=(prof(il-1)-itt)/(prof(il-1)-prof(il))
           pressure=pres(il-1)-coef*(pres(il-1)-pres(il))
           write(*,*)'COEF,P',coef,pressure
        endif 
      endif
      il=il+1
      go to 10
888   continue
      write(*,*) 'Prof ', itt,'P (GPa)=',pressure
      a=-5.104
      b=132.899
      c=1120.661
      tsold=a*pressure**2+b*pressure+c
      tsold=tsold+273.15
c     tsolwet d'apres mail Yan du 24/02/2019 a 15h13
      BB=65999.65518+9727.586207*pressure
      tsolw_3000=(1./tsold)-(RR*log(1.-0.017*sqrt(3000.))/BB)
      tsolw_3000=1./tsolw_3000 
      tsolw_200=(1./tsold)-(RR*log(1.-0.017*sqrt(200.))/BB)
      tsolw_200=1./tsolw_200 
      tsolw_800=(1./tsold)-(RR*log(1.-0.017*sqrt(800.))/BB)
      tsolw_800=1./tsolw_800 

      tsoly=1373+3.3*itt

      fprof=float(itt)
      tsoltak=1326.+273.15+1.018*(fprof-50)
      close(10)
      end
c-------------------------------------------------------------
      SUBROUTINE lecsmac(smacdata)
c ------------------------------------------------------------------
      parameter(NLAT=90,NLON=180,NLALO=NLAT*NLON,NHIST=200)
      real smacdata(NLAT,NLON)
c     real smacdata(NLALO)
      integer iage
      character*80 ligne,toto
c---------------------------------------------------------
c Cette routine lit 3SMAC et sort la tecto en fonction 
c de la latitude et longitude.
c---------------------------------------------------------
c     Les fichiers 3SMAC sont donnes tout les 2*2 degres
c     avec val(ilat,ilon)
c     colat de 0 a 180 degres en partant du pole Nord
c     lon de 0 a 360 degres  

c    ouverture des fichiers
c      toto='/Users/edebayle/UNIX/3SMAC.2v6rem/brut/datatecto'
       toto='../data/datatecto'
      open(7,file=toto)
      read(7,'(a)')ligne
      write(*,'(a)')ligne
      read(7,'(a)')ligne
      write(*,'(a)')ligne
      read(7,'(a)')ligne
      write(*,'(a)')ligne
      read(7,*,err=91,end=92) smacdata
92    write(*,*) '3SMAC file lu'
      go to 93
91    write(*,*) 'Problem reading in datatecto'
93    continue
      close(7)
      end
c------------------------------------------------------------------
